{-- Algebras - Interface between TerraLib and Haskell

    (c) Sergio Costa (INPE) - Setembro, 2005

	This program is free software; you can redistribute it 
    and/or modify it under the terms of the GNU General 
    Public License 2.1 as published by the Free Software Foundation
    (http://www.opensource.org/licenses/gpl-license.php)
--}

{--  --}

module Algebras.Base
	(
		
		Points (..), Lines (..), Polygons (..),
	
		Ids (..), ObjectId (..),
	
		Set (..) , TopologyOps (..), Relations (..), centroid,  distance , llength , area ,
	
			
		-- * The @TeGeoObject@ type
		TeGeoObject (..),
	
		-- * The @TeGeoObjects@ class
		GeoObjects (..), 
	
		
		-- * The @Value@ type 
		Value (..),
			
		-- * The @Attribute@ type 
		Attribute (..),
			
		-- * The @Values@ class
		Values (..),
			
		-- * The @Attributes@ class
		Attributes (..), getValuebyName,

		loadRasterFile, loadRaster, Rasters (..), importRaster, importRasterWParameter
	)
	 where


import Algebras.Base.Geometries
import Algebras.Base.Points
import Algebras.Base.Lines
import Algebras.Base.Polygons
import Algebras.Base.Ids
import Algebras.Base.Operations
import Algebras.Base.GeoObjects
import Algebras.Base.Attribute 
import Algebras.Base.Raster
