module TerraHS
(
	TeDatabase(..),
	TeDatabases (..),

	-- Geometry.hs
	TeGeometry(..), TePoint(..), TePolygon(..), TeLine2D(..), TeCell(..), TeBox(..),
	TePointSet(..) ,TePolygonSet(..) ,TeLineSet(..),TeCellSet(..), 
	
	-- STInstance.hs	
	TeSTInstance (..),

	-- GeometyAlgorithms
	Topology (..), Overlay (..),
	
			
		Points (..), Lines (..), Polygons (..),
	
		Ids (..), ObjectId (..),
	
		Set (..) , TopologyOps (..), Relations (..), centroid,  distance , llength , area ,
	
	
		TeRaster (..),
		
		loadRasterFile, loadRaster, Rasters (..), importRaster, importRasterWParameter,
			
		-- * The @TeGeoObject@ type
		TeGeoObject (..),
	
		-- * The @TeGeoObjects@ class
		GeoObjects (..), 
	
		
		-- * The @Value@ type 
		Value (..),
			
		-- * The @Attribute@ type 
		Attribute (..),
			
		-- * The @Values@ class
		Values (..),
			
		-- * The @Attributes@ class
		Attributes (..), getValuebyName,

		-- * The Databases Module class
		Connection (..), Databases (..),
		
		-- * The Object Module class
		Pointer (..), Convert (..), Element (..), Size (..)
)

 where

import TerraHS.TerraLib
import TerraHS.TerraLib.TeRaster
import TerraHS.Misc
import Algebras.Base







